from traceback import print_tb

from azure.cognitiveservices.vision.computervision import ComputerVisionClient
from azure.cognitiveservices.vision.computervision.models import OperationStatusCodes
from azure.cognitiveservices.vision.computervision.models import VisualFeatureTypes
from msrest.authentication import CognitiveServicesCredentials

import os 
from PIL import Image
import cv2
from array import array
from IPython.display import display
import os
import cv2
import numpy as np
from PIL import Image
import sys
import pandas as pd
import time
import glob
import argparse
import streamlit as st

def cnvrt_to_jpeg(path_,name):

    if path_ is not None:
        img = Image.open(path_)
        st.image(img, caption='Image')
        # out = img.convert("RGB")
        # out = img.resize((700,900),Image.ANTIALIAS)
        outfile = str(name).split('.')[0] + '.jpg'
        img.save('images/'+outfile, "JPEG")#, quality=90)
        # img = Image.open('images/'+outfile)
        # out = img.resize((700,900),Image.ANTIALIAS)
        # out.save('images/'+outfile, "JPEG")

def save_images(img_path,coordinates,save_path):

        img = Image.open(img_path)
        img = img.resize((700,900))
        [x, y, w, h] = coordinates
        img = img.crop((x, y, x+w, y+h))        
        img_path = img_path.split('/')[1]
        img.save(save_path[0]+'/'+img_path)

def save_cropped_images(img_path):
    
    coordinates = [419,755,264,136]
    save_path = ['bottom_third_box_images'] #,'bottom_third_box_images_1']
    save_images(img_path,coordinates,save_path)


def IOU(l1,l2):

    [x1,y1,w1,h1] = l1
    [x2,y2,w2,h2 ]= l2

    x_left1 = x1
    y_top1 = y1
    x_right1 = w1
    y_bottom1 = h1

    x_left2 = x2
    y_top2 = y2
    x_right2 = w2
    y_bottom2 = h2

    boxA = [x_left1,y_top1,x_right1,y_bottom1]
    boxB = [x_left2,y_top2,x_right2,y_bottom2] 

    xA = max(boxA[0], boxB[0])
    yA = max(boxA[1], boxB[1])
    xB = min(boxA[2], boxB[2])
    yB = min(boxA[3], boxB[3])
    # '''compute the area of intersection rectangle'''
    interArea = max(0, xB - xA + 1) * max(0, yB - yA + 1)
    # '''
    # compute the area of both the prediction and ground-truth
    # rectangles
    # '''
    boxAArea = (boxA[2] - boxA[0] + 1) * (boxA[3] - boxA[1] + 1)
    boxBArea = (boxB[2] - boxB[0] + 1) * (boxB[3] - boxB[1] + 1)
    # ''' 
    # compute the intersection over union by taking the intersection
    # area and dividing it by the sum of prediction + ground-truth
    # areas - the interesection area'''
    iou = interArea / float(boxAArea + boxBArea - interArea)
    return iou

def tale3_y_coordinate_based(text_lst_,bound_lst_):
    y_coordinates = []
    table_coordinates = []
    for coordinates in bound_lst_:
        if coordinates[0] in range(15-14,15+10):
            idx = bound_lst_.index(coordinates)
            y_coordinates.append(coordinates[1])

    field = []
    data = []
    for y_coordinate in y_coordinates:
        field = []
        row_coordinates = []
        for bound_coordinate in bound_lst_:
            if y_coordinate in range(int(bound_coordinate[1]-5),int(bound_coordinate[1]+10)):
                idx = bound_lst_.index(bound_coordinate)
                field.append(text_lst_[idx])
                row_coordinates.append(bound_coordinate)
        data.append(field)
        table_coordinates.append(row_coordinates)

    return data,table_coordinates

def y_coordinate_based(text_lst_,bound_lst_):
    y_coordinates = []
    table_coordinates = []
    for coordinates in bound_lst_:
        if coordinates[0] in range(25-10,25+10):
            idx = bound_lst_.index(coordinates)
            y_coordinates.append(coordinates[1])

    field = []
    data = []
    for y_coordinate in y_coordinates:
        field = []
        row_coordinates = []
        for bound_coordinate in bound_lst_:
            if y_coordinate in range(int(bound_coordinate[1]-5),int(bound_coordinate[1]+10)):
                idx = bound_lst_.index(bound_coordinate)
                field.append(text_lst_[idx])
                row_coordinates.append(bound_coordinate)
        data.append(field)
        table_coordinates.append(row_coordinates)
    table_data = pd.DataFrame(data)
    table_coordinates = pd.DataFrame(table_coordinates)
    return table_data,table_coordinates

def extract(img_path,computervision_client):
    text_lst = []
    bound_lst = []
    read_response = computervision_client.read_in_stream(open(img_path,"rb"),language='en',  raw=True)
    read_operation_location = read_response.headers["Operation-Location"]
    operation_id = read_operation_location.split("/")[-1]
    while True:
        read_result = computervision_client.get_read_result(operation_id)
        if read_result.status not in ['notStarted', 'running']:
            break
        time.sleep(1)
    if read_result.status == OperationStatusCodes.succeeded:
            for text_result in read_result.analyze_result.read_results:
                for line in text_result.lines:
                    text_lst.append(line.text)
                    bound_lst.append(line.bounding_box)

    return text_lst,bound_lst

def get_pobox(text_lst):
    for idx,i in enumerate(text_lst):
        a = i.replace('.','')
        a  = ''.join(a.split(' ')).lower()
        if 'pobox'in a :
            break
    return idx,a

def table_3(computervision_client):

        img_path = [i for i in os.listdir('bottom_third_box_images') if i.endswith('.jpg')][0]
        img_path = 'bottom_third_box_images/'+img_path
        text_lst,bound_lst =  extract(img_path,computervision_client)
        table3_data,table_coordinates = tale3_y_coordinate_based(text_lst,bound_lst)
        table3_data = [[' '.join(i)] if len(i)>1 else i for i in table3_data]
        try:
            dct = {'fields':['physician Address(m2)','m3','m4','physician NPIID'],
            'info':[table3_data[0][0],table3_data[1][0],table3_data[2][0],table3_data[3][0].split(' ')[0]]}
        except:
            dct = {'fields':['Facility Address(m2)','m3','m4','Facility NPIID'],
            'info':['Null','Null','Null','Null']}
        df3=pd.DataFrame(dct)
        return df3
def main():
    
    subscription_key = "4d2ccba6557b4eb88e28e49260a473d2"
    endpoint = "https://allianzeformautomation.cognitiveservices.azure.com/"
    computervision_client = ComputerVisionClient(endpoint, CognitiveServicesCredentials(subscription_key))

    html_temp = """
    <div style="background-color:tomato;padding:10px">
    <h2 style="color:white;text-align:center;">Data Extraction </h2>
    </div>
    """
    html_temp1 = """
    <div style="background-color:DarkViolet;padding:0px">
    <h2 style="color:white;text-align:center;">Upload Image </h2>
    </div>
    """


    st.header(html_temp,'Data Extraction')
    st.subheader("Upload Image")
    image_file = st.file_uploader("Upload Images", type=["tif"])
    if image_file:

        cnvrt_to_jpeg(image_file,image_file.name)

        img_path = [i for i in os.listdir('images') if i.endswith('.jpg')][0]
        img_path = 'images/'+img_path

        text_lst,bound_lst =  extract(img_path,computervision_client)

        data = pd.read_csv('ref_coordinates_new.csv')

        # """ direct field extraction """

        data_lst = data.values
        new_data = []
        for i in data_lst:
            iou_lst = []
            for j in bound_lst:
                [x,y,w,h]=[j[0]-5,j[1]-5,j[6]+10,j[7]+10]
                [a,b,c,d] = i[1:].tolist()
                iou_lst.append(IOU([a,b,c,d],[x,y,w,h]))
            if max(iou_lst)>0:
                var_ = bound_lst[iou_lst.index(max(iou_lst))]
                [m,n,o,p] = [var_[0],var_[1],var_[4],var_[5]]
                # print(i[0],text_lst[iou_lst.index(max(iou_lst)),[x,y,w,h]])
                new_data.append([i[0],text_lst[iou_lst.index(max(iou_lst))],[m,n,o,p]])
            else:
                new_data.append([i[0],'Null','Null'])    
        idx,pobox = get_pobox(text_lst)
        j = bound_lst[idx]
        [x,y,w,h]=[j[0],j[1],j[4],j[5]]
        new_data.append(['PO BOX',pobox.replace('pobox',''),[x,y,w,h]])
        df1 = pd.DataFrame(new_data,columns=['fields','info','coordinates'])


        # """ region extraction """
        second_box = []
        third_box = []
        fourth_box = []

        for i,j in zip(text_lst,bound_lst):
            [x,y,w,h]=[j[0]-5,j[1]-5,j[6]+10,j[7]+10]

            # """ table-2"""
            # [x1,y1,x2,y2]=[199, 759, 230+199, 759+119]
            # if x>=x1 and y>=y1 and w<=x2 and h<=y2 and i.lower()!='x' and len(i)>3:
            #     second_box.append([i,j[0],j[1],j[4],j[5]])

            # """ table-4 """
            [x1,y1,x2,y2]=[16, 592, 16+665, 592+177]
            if x>=x1 and y>=y1 and w<=x2 and h<=y2:
                fourth_box.append([i,j[0],j[1],j[4],j[5]])

        # """ table-2 data """

        # try:
        #     dct = {'fields':['Federal Tax id and SSN/EIN','Physician Name and Signature '],'info':[second_box[0][0],second_box[1][0]]
        #     ,'coordinates':[second_box[0][1:],second_box[1][1:]]}
        # except:
        #     dct = {'fields':['Null','Null'],'info':['Null','Null'],'coordinates':['Null','Null']}
        #     pass
        # df2=pd.DataFrame(dct)

        # """ table-3 data """
        save_cropped_images(img_path)
        df3 = table_3(computervision_client)
        display(df3)

        # """ table-4 data """
        table_4_text = np.array(fourth_box)[:,0].tolist()
        table_4_coordinates = np.array(fourth_box)[:,1:].tolist()
        table_4_coordinates = [[int(float(c)) for c in coo] for coo in table_4_coordinates]

        table = y_coordinate_based(table_4_text,table_4_coordinates)
        df4,table_coordinates =table

        # """ data concatenation """
        new_data = pd.concat([df1,df3],axis=0)
        new_data_table_data = pd.concat([df4,table_coordinates],axis=1)

        # """ clean the third box folder """
        files = glob.glob('bottom_third_box_images/*')
        for f in files:
            os.remove(f)
        files = glob.glob('images/*')
        for f in files:
            os.remove(f)
        files = glob.glob('final_coordinate_csv/*')
        for f in files:
            os.remove(f)

        # """ saving the data """
        img_path = img_path.split('/')[1]
        # img_path = str(img_path).split('.')[0]
        writer = pd.ExcelWriter('final_coordinate_csv/'+img_path[:-4]+'.xlsx', engine = 'xlsxwriter')
        new_data.to_excel(writer, sheet_name = 'data')
        new_data_table_data.to_excel(writer, sheet_name = 'table_data')
        writer.save()
        writer.close()

        with open('final_coordinate_csv/'+img_path[:-4]+'.xlsx', 'rb') as f:
            st.download_button('Download File', f, file_name='final_csv/'+img_path[:-4]+'.xlsx') 


main()
